    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.util.Date

    java.lang.Object
       |
       +----java.util.Date

public class Date
extends Object
implements Serializable, Cloneable

The class `Date` represents a specific instant in time, with millisecond precision.

Prior to JDK 1.1, the class `Date` had two additional functions. It allowed the interpretation of dates as year, month, day, hour, minute, and second values. It also allowed the formatting and parsing of date strings. Unfortunately, the API for these functions was not amenable to internationalization. As of JDK 1.1, the `Calendar` class should be used to convert between dates and time fields and the `DateFormat` class should be used to format and parse date strings. The corresponding methods in `Date` are deprecated.

Although the `Date` class is intended to reflect coordinated universal time (UTC), it may not do so exactly, depending on the host environment of the Java Virtual Machine. Nearly all modern operating systems assume that 1 day = 24 × 60 × 60 = 86400 seconds in all cases. In UTC, however, about once every year or two there is an extra second, called a "leap second." The leap second is always added as the last second of the day, and always on December 31 or June 30. For example, the last minute of the year 1995 was 61 seconds long, thanks to an added leap second. Most computer clocks are not accurate enough to be able to reflect the leap-second distinction.

Some computer standards are defined in terms of Greenwich mean time (GMT), which is equivalent to universal time (UT). GMT is the "civil" name for the standard; UT is the "scientific" name for the same standard. The distinction between UTC and UT is that UTC is based on an atomic clock and UT is based on astronomical observations, which for all practical purposes is an invisibly fine hair to split. Because the earth's rotation is not uniform (it slows down and speeds up in complicated ways), UT does not always flow uniformly. Leap seconds are introduced as needed into UTC so as to keep UTC within 0.9 seconds of UT1, which is a version of UT with certain corrections applied. There are other time and date systems as well; for example, the time scale used by the satellite-based global positioning system (GPS) is synchronized to UTC but is not adjusted for leap seconds. An interesting source of further information is the U.S. Naval Observatory, particularly the Directorate of Time at:

`http://tycho.usno.navy.mil`

and their definitions of "Systems of Time" at:

`http://tycho.usno.navy.mil/systime.html`

In all methods of class `Date` that accept or return year, month, date, hours, minutes, and seconds values, the following representations are used:

- A year y is represented by the integer y `- 1900`.
- A month is represented by an integer form 0 to 11; 0 is January, 1 is February, and so forth; thus 11 is December.
- A date (day of month) is represented by an integer from 1 to 31 in the usual manner.
- An hour is represented by an integer from 0 to 23. Thus, the hour from midnight to 1 a.m. is hour 0, and the hour from noon to 1 p.m. is hour 12.
- A minute is represented by an integer from 0 to 59 in the usual manner.
- A second is represented by an integer from 0 to 60; the value 60 occurs only for leap seconds and even then only in Java implementations that actually track leap seconds correctly.

In all cases, arguments given to methods for these purposes need not fall within the indicated ranges; for example, a date may be specified as January 32 and is interpreted as meaning February 1.

See Also:
  DateFormat, Calendar, TimeZone

##

Date()
  Allocates a `Date` object and initializes it so that it represents the time at which it was allocated measured to the nearest millisecond.
Date(int, int, int)
  Allocates a `Date` object and initializes it so that it represents midnight, local time, at the beginning of the day specified by the `year`, `month`, and `date` arguments. Deprecated.
Date(int, int, int, int, int)
  Allocates a `Date` object and initializes it so that it represents the specified hour and minute, local time, of the date specified by the `year`, `month`, `date`, `hrs`, and `min` arguments. Deprecated.
Date(int, int, int, int, int, int)
  Allocates a `Date` object and initializes it so that it represents the specified hour, minute, and second, local time of the date specified by the `year`, `month`, `date`, `hrs`, `min`, and `sec` arguments. Deprecated.
Date(long)
  Allocates a `Date` object and initializes it to represent the specified number of milliseconds since January 1, 1970, 00:00:00 GMT.
Date(String)
  Allocates a `Date` object and initializes it so that it represents the date and time indicated by the string `s`, which is interpreted as if by the `parse` method. Deprecated.

##

after(Date)
  Tests if this date is after the specified date.
before(Date)
  Tests if this date is before the specified date.
equals(Object)
  Compares two dates.
getDate()
  Returns the day of the month represented by this date. Deprecated.
getDay()
  Returns the day of the week represented by this date. Deprecated.
getHours()
  Returns the hour represented by this date. Deprecated.
getMinutes()
  Returns the number of minutes past the hour represented by this date. Deprecated.
getMonth()
  Returns the month represented by this date. Deprecated.
getSeconds()
  Returns the number of seconds past the minute represented by this date. Deprecated.
getTime()
  Returns the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by this date.
getTimezoneOffset()
  Returns the local time-zone offset. Deprecated.
getYear()
  Returns the year represented by this date, minus 1900. Deprecated.
hashCode()
  Returns a hash code value for this object.
parse(String)
  Given a string representing a time, parse it and return the time value. Deprecated.
setDate(int)
  Sets the day of the month of this date to the specified value. Deprecated.
setHours(int)
  Sets the hour of this date to the specified value. Deprecated.
setMinutes(int)
  Sets the minutes of this date to the specified value. Deprecated.
setMonth(int)
  Sets the month of this date to the specified value. Deprecated.
setSeconds(int)
  Sets the seconds of this date to the specified value. Deprecated.
setTime(long)
  Sets this date to represent the specified number of milliseconds since January 1, 1970, 00:00:00 GMT.
setYear(int)
  Sets the year of this date to be the specified value plus 1900. Deprecated.
toGMTString()
  Creates a string representation of this date. Deprecated.
toLocaleString()
  Creates a string representation of this date in an implementation-dependent form. Deprecated.
toString()
  Creates a canonical string representation of the date.
UTC(int, int, int, int, int, int)
  Determines the date and time based on the arguments. Deprecated.

##

Date

     public Date()

  Allocates a `Date` object and initializes it so that it represents the time at which it was allocated measured to the nearest millisecond.

  See Also:
    currentTimeMillis

Date

     public Date(long date)

  Allocates a `Date` object and initializes it to represent the specified number of milliseconds since January 1, 1970, 00:00:00 GMT.

  Parameters:
    date - the milliseconds since January 1, 1970, 00:00:00 GMT.
  See Also:
    currentTimeMillis

Date

     public Date(int year,
                 int month,
                 int date)

  Note: Date() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(year + 1900, month, date)` or `GregorianCalendar(year + 1900, month, date)`.

  Allocates a `Date` object and initializes it so that it represents midnight, local time, at the beginning of the day specified by the `year`, `month`, and `date` arguments.

  Parameters:
    year - the year minus 1900.
    month - the month between 0-11.
    date - the day of the month between 1-31.
  See Also:
    Calendar

Date

     public Date(int year,
                 int month,
                 int date,
                 int hrs,
                 int min)

  Note: Date() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(year + 1900, month, date, hrs, min)` or `GregorianCalendar(year + 1900, month, date, hrs, min)`.

  Allocates a `Date` object and initializes it so that it represents the specified hour and minute, local time, of the date specified by the `year`, `month`, `date`, `hrs`, and `min` arguments.

  Parameters:
    year - the year minus 1900.
    month - the month between 0-11.
    date - the day of the month between 1-31.
    hrs - the hours between 0-23.
    min - the minutes between 0-59.
  See Also:
    Calendar

Date

     public Date(int year,
                 int month,
                 int date,
                 int hrs,
                 int min,
                 int sec)

  Note: Date() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(year + 1900, month, date, hrs, min, sec)` or `GregorianCalendar(year + 1900, month, date, hrs, min, sec)`.

  Allocates a `Date` object and initializes it so that it represents the specified hour, minute, and second, local time of the date specified by the `year`, `month`, `date`, `hrs`, `min`, and `sec` arguments.

  Parameters:
    year - the year minus 1900.
    month - the month between 0-11.
    date - the day of the month between 1-31.
    hrs - the hours between 0-23.
    min - the minutes between 0-59.
    sec - the seconds between 0-59.
  See Also:
    Calendar

Date

     public Date(String s)

  Note: Date() is deprecated. As of JDK version 1.1, replaced by `DateFormat.parse(String s)`.

  Allocates a `Date` object and initializes it so that it represents the date and time indicated by the string `s`, which is interpreted as if by the `parse` method.

  Parameters:
    s - a string representation of the date.
  See Also:
    DateFormat, parse

##

UTC

     public static long UTC(int year,
                            int month,
                            int date,
                            int hrs,
                            int min,
                            int sec)

  Note: UTC() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(year + 1900, month, date, hrs, min, sec)` or `GregorianCalendar(year + 1900, month, date, hrs, min, sec)`, using a UTC `TimeZone`, followed by `Calendar.getTime().getTime()`.

  Determines the date and time based on the arguments. The arguments are interpreted in UTC, not in the local time zone

  Parameters:
    year - the year minus 1900.
    month - the month between 0-11.
    date - the day of the month between 1-31.
    hrs - the hours between 0-23.
    min - the minutes between 0-59.
    sec - the seconds between 0-59.
  Returns:
    the number of milliseconds since January 1, 1970, 00:00:00 GMT for the date and time specified by the arguments.
  See Also:
    Calendar

parse

     public static long parse(String s)

  Note: parse() is deprecated. As of JDK version 1.1, replaced by `DateFormat.parse(String s)`.

  Given a string representing a time, parse it and return the time value. This method recognizes most standard syntaxes.

  It accepts many syntaxes; in particular, it recognizes the IETF standard date syntax: "Sat, 12 Aug 1995 13:30:00 GMT". It also understands the continental U.S. time-zone abbreviations, but for general use, a time-zone offset should be used: "Sat, 12 Aug 1995 13:30:00 GMT+0430" (4 hours, 30 minutes west of the Greenwich meridian). If no time zone is specified, the local time zone is assumed. GMT and UTC are considered equivalent.

  If the recognized year number is less than 100, it is interpreted as an abbreviated year relative to a century of which dates are within 80 years before and 19 years after the time when the Date class is initialized. After adjusting the year number, 1900 is subtracted from it. For example, if the current year is 1999 then years in the range 19 to 99 are assumed to mean 1919 to 1999, while years from 0 to 18 are assumed to mean 2000 to 2018. Note that this is slightly different from the interpretation of years less than 100 that is used in `SimpleDateFormat`.

  Parameters:
    s - a string to be parsed as a date.
  Returns:
    the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by the string argument.
  See Also:
    DateFormat

getYear

     public int getYear()

  Note: getYear() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.YEAR) - 1900`.

  Returns the year represented by this date, minus 1900.

  Returns:
    the year represented by this date, minus 1900.
  See Also:
    Calendar

setYear

     public void setYear(int year)

  Note: setYear() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(Calendar.YEAR, year + 1900)`.

  Sets the year of this date to be the specified value plus 1900.

  Parameters:
    year - the year value.
  See Also:
    Calendar

getMonth

     public int getMonth()

  Note: getMonth() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.MONTH)`.

  Returns the month represented by this date. The value returned is between `0` and `11`, with the value `0` representing January.

  Returns:
    the month represented by this date.
  See Also:
    Calendar

setMonth

     public void setMonth(int month)

  Note: setMonth() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(Calendar.MONTH, int month)`.

  Sets the month of this date to the specified value.

  Parameters:
    month - the month value between 0-11.
  See Also:
    Calendar

getDate

     public int getDate()

  Note: getDate() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.DAY_OF_MONTH)`.

  Returns the day of the month represented by this date. The value returned is between `1` and `31`.

  Returns:
    the day of the month represented by this date.
  See Also:
    Calendar

setDate

     public void setDate(int date)

  Note: setDate() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(Calendar.DAY_OF_MONTH, int date)`.

  Sets the day of the month of this date to the specified value.

  Parameters:
    date - the day of the month value between 1-31.
  See Also:
    Calendar

getDay

     public int getDay()

  Note: getDay() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.DAY_OF_WEEK)`.

  Returns the day of the week represented by this date. The value returned is between `0` and `6`, where `0` represents Sunday.

  Returns:
    the day of the week represented by this date.
  See Also:
    Calendar

getHours

     public int getHours()

  Note: getHours() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.HOUR_OF_DAY)`.

  Returns the hour represented by this date. The value returned is between `0` and `23`, where `0` represents midnight.

  Returns:
    the hour represented by this date.
  See Also:
    Calendar

setHours

     public void setHours(int hours)

  Note: setHours() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(Calendar.HOUR_OF_DAY, int hours)`.

  Sets the hour of this date to the specified value.

  Parameters:
    hours - the hour value.
  See Also:
    Calendar

getMinutes

     public int getMinutes()

  Note: getMinutes() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.MINUTE)`.

  Returns the number of minutes past the hour represented by this date. The value returned is between `0` and `59`.

  Returns:
    the number of minutes past the hour represented by this date.
  See Also:
    Calendar

setMinutes

     public void setMinutes(int minutes)

  Note: setMinutes() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(Calendar.MINUTE, int minutes)`.

  Sets the minutes of this date to the specified value.

  Parameters:
    minutes - the value of the minutes.
  See Also:
    Calendar

getSeconds

     public int getSeconds()

  Note: getSeconds() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.SECOND)`.

  Returns the number of seconds past the minute represented by this date. The value returned is between `0` and `60`. The value `60` can only occur on those Java Virtual Machines that take leap seconds into account.

  Returns:
    the number of seconds past the minute represented by this date.
  See Also:
    Calendar

setSeconds

     public void setSeconds(int seconds)

  Note: setSeconds() is deprecated. As of JDK version 1.1, replaced by `Calendar.set(Calendar.SECOND, int seconds)`.

  Sets the seconds of this date to the specified value.

  Parameters:
    seconds - the seconds value.
  See Also:
    Calendar

getTime

     public long getTime()

  Returns the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by this date.

  Returns:
    the number of milliseconds since January 1, 1970, 00:00:00 GMT represented by this date.

setTime

     public void setTime(long time)

  Sets this date to represent the specified number of milliseconds since January 1, 1970, 00:00:00 GMT.

  Parameters:
    time - the number of milliseconds.

before

     public boolean before(Date when)

  Tests if this date is before the specified date.

  Parameters:
    when - a date.
  Returns:
    `true` if this date is before the argument date; `false` otherwise.

after

     public boolean after(Date when)

  Tests if this date is after the specified date.

  Parameters:
    when - a date.
  Returns:
    `true` if this date is after the argument date; `false` otherwise.

equals

     public boolean equals(Object obj)

  Compares two dates. The result is `true` if and only if the argument is not `null` and is a `Date` object that represents the same point in time, to the millisecond, as this object.

  Thus, two `Date` objects are equal if and only if the `getTime` method returns the same `long` value for both.

  Parameters:
    obj - the object to compare with.
  Returns:
    `true` if the objects are the same; `false` otherwise.
  Overrides:
    equals in class Object
  See Also:
    getTime

hashCode

     public int hashCode()

  Returns a hash code value for this object.

  Returns:
    a hash code value for this object.
  Overrides:
    hashCode in class Object

toString

     public String toString()

  Creates a canonical string representation of the date. The result is of the form `"Sat Aug 12 02:30:00 PDT 1995"`.

  Returns:
    a string representation of this date.
  Overrides:
    toString in class Object

toLocaleString

     public String toLocaleString()

  Note: toLocaleString() is deprecated. As of JDK version 1.1, replaced by `DateFormat.format(Date date)`.

  Creates a string representation of this date in an implementation-dependent form. The intent is that the form should be familiar to the user of the Java application, wherever it may happen to be running. The intent is comparable to that of the "`%c`" format supported by the `strftime()` function of ISO C.

  Returns:
    a string representation of this date, using the locale conventions.
  See Also:
    DateFormat

toGMTString

     public String toGMTString()

  Note: toGMTString() is deprecated. As of JDK version 1.1, replaced by `DateFormat.format(Date date)`, using a GMT `TimeZone`.

  Creates a string representation of this date. The result is of the form:
  `"12 Aug 1995 02:30:00 GMT"`

  in which the day of the month is always one or two digits. The other fields have exactly the width shown. The time zone is always given as "GMT".

  Returns:
    a string representation of this date, using the Internet GMT conventions.
  See Also:
    DateFormat

getTimezoneOffset

     public int getTimezoneOffset()

  Note: getTimezoneOffset() is deprecated. As of JDK version 1.1, replaced by `Calendar.get(Calendar.ZONE_OFFSET) + Calendar.get(Calendar.DST_OFFSET)`.

  Returns the local time-zone offset. The time-zone offset is the number of minutes that must be added to GMT to give the local time zone. This value includes the correction, if necessary, for daylight saving time.

  Returns:
    the time-zone offset, in minutes, for the current locale.
  See Also:
    Calendar, TimeZone

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.